#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "AkelDLL.h"


//Functions prototypes
LRESULT CALLBACK NewMainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

//Global variables
WNDPROCDATA *NewMainProcData=NULL;


//Identification
extern "C" void __declspec(dllexport) DllAkelPadID(PLUGINVERSION *pv)
{
  pv->dwAkelDllVersion=AKELDLL;
  pv->dwExeMinVersion3x=MAKE_IDENTIFIER(3, 7, 4, 0);
  pv->dwExeMinVersion4x=MAKE_IDENTIFIER(4, 4, 0, 0);
  pv->pPluginName="RecentFiles";
}

//Plugin extern function
extern "C" void __declspec(dllexport) DeleteNonExistent(PLUGINDATA *pd)
{
  if (pd->lpbAutoLoad)
  {
    *pd->lpbAutoLoad=TRUE;
    return;
  }

  NewMainProcData=NULL;
  SendMessage(pd->hMainWnd, AKD_SETMAINPROC, (WPARAM)NewMainProc, (LPARAM)&NewMainProcData);

  SendMessage(pd->hMainWnd, WM_COMMAND, IDM_RECENT_FILES, 0);

  SendMessage(pd->hMainWnd, AKD_SETMAINPROC, (WPARAM)NULL, (LPARAM)&NewMainProcData);
  NewMainProcData=NULL;
}

extern "C" void __declspec(dllexport) Show(PLUGINDATA *pd)
{
  RECT rc;

  if (pd->lpbAutoLoad)
  {
    *pd->lpbAutoLoad=FALSE;
    return;
  }

  GetWindowRect(pd->hWndEdit, &rc);
  TrackPopupMenu(pd->hMenuRecentFiles, TPM_LEFTBUTTON, rc.left, rc.top, 0, pd->hMainWnd, NULL);
}

LRESULT CALLBACK NewMainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == AKDN_RECENTFILESDELETE)
  {
    BOOL *bShow=(BOOL *)lParam;
  
    *bShow=FALSE;
  }

  //Call next procedure
  return NewMainProcData->NextProc(hWnd, uMsg, wParam, lParam);
}

//Entry point
extern "C" BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  if (fdwReason == DLL_PROCESS_ATTACH)
  {
  }  
  else if (fdwReason == DLL_THREAD_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_DETACH)
  {
  }
  else if (fdwReason == DLL_PROCESS_DETACH)
  {
  }
  return TRUE;
}
